/* ---- (c) SETA DOMINIO PUBLICO ----- */
/* ---- LINUX X-WIN CON BUFFER ------- */
/* ---- MODIFICADO 18-10-1999 -------- */
/* ---- TRABAJO EN MODO INDEXADO ----- */
#include "stdio.h"
#include "stdlib.h"
#include "string.h" 
#include <sys/time.h> 

#include <X11/Xlib.h>
#include <X11/Xutil.h>

#include "font.h"


int init(int ancho, int alto);

extern int wXWIN;
extern int hXWIN;

/* --- Rutinas bajo nivel --- */

void clear(unsigned char c);
void plot(int x,int y);
int point(int x,int y);
void line(int x,int y,int xx,int yy);
void bar(int x,int y,int xx,int yy);
void setfont(char *nombre);
int loadfont(char *nombre);
void impri (int x,int y,unsigned char ca);
void paleta(void);
void paletapal(void);

void mode(int mode_code);

int inkey2(void);
int inkey(void);

void waits(int s);
void waitx(int s);
void waitm(int n);
unsigned int Ctime(void);
void velocidad(void);
void mouse(int x);
void mouses(int x,int y,int t);

void igetcolors(void);
void setcolor(void);

/* --- Rutinas normales --- */
void box(int x,int y,int xx,int yy);
void printc(int x,int y,char *texto);
void printn(int x,int y,long num);
void error(int z);

/* ---- rutinas Xwin ---- */

void do_KeyPress (void);
void do_KeyRelease (void);
int xinkey(void);
void redraw(void);
/* ---------------------- */

 char *pv,*pv1,*pvx;
unsigned int *pvi,*pvi1;
unsigned short int *pvs,*pvs1;
int INK,PAPER,SPEED,SETIM,SETBUFFER=0;
int XMOUSE,YMOUSE,KMOUSE,CMOUSE,IMOUSE=255,PMOUSE=4;
int MOUSE=1;
int FONTX=1,FONTY=2,FONTXX,FONTYY,CX,CY;
FILE *pf;
char VARI[80];
int *VARI0;
unsigned char tabla[2040],pal[800];
unsigned char  COLOR[16];
unsigned long ICOLOR[256];
unsigned int I2COLOR[256];
unsigned char tleta[48]= {0,0,0,63,63,63,
			  0,63,63,63,0,63,
			  0,0,63,63,63,0,
			  0,63,0,63,0,0,
			  32,32,32,47,47,47,
			  0,47,47,47,0,47,
			  0,0,47,47,47,0,
			  0,47,0,47,0,0
			  };
char *grafi[16];
char *grafip[16];

/* ----- X-WIN ----- */
Window		Miventana;
Display		*Midisplay; 
int		Mipantalla;
XSetWindowAttributes Miattr;
unsigned long	Mimask = 0L;
GC		Migc;
XGCValues	Migcv;
XColor		Micolor;
static Colormap	Mimapa;
XEvent		*Mievent;
Visual 		*Mivisual;
int		Midepth;
int		nbscreen;


Font		Mifont;
char 		INKEY;
int		INKEY2;
char 		NINKEY;
int		NINKEY2;

int		Wancho;
int		Walto;

unsigned int		tamaBuffer;
char            *pixmapBuffer;
XImage          *offscreenBuffer;



int init(int ancho,int alto)
{
    wXWIN = ancho; 
	hXWIN= alto;
	mode(-1);
}

/* ----- copia el buffer a la pantalla ----- */
void redraw(void)
{
	XPutImage(Midisplay, Miventana, Migc, offscreenBuffer,0,0,0,0,Wancho,Walto);
}

/*---- IMPRIME CARACTER ----*/
void impri (int x,int y,unsigned char ca)
{

unsigned  int z,zz,zz1,z2,zz2;
char n,c;
int d,d1;

   if(SETBUFFER==1)
    {  
	zz=ca*8;
	d1=y*Wancho;
        switch(Midepth)
        {
         case 8:
          pv1=pvx+tamaBuffer;
           if(FONTX==1 && FONTY==1)
              {
  	           d=d1+x;
                   zz1=d;
                   pv=pvx+zz1;
                   zz2=Wancho-8;
                   for(z=zz;z<zz+8;z++)
                   {
                    n=tabla[z];
                    for (c=0;c<8;c++)
                      {
                       if(pv<=pv1)
                       if(n&128) { *pv=INK;} else { *pv=PAPER;} 
                       pv++;
                       n=n<<1;
                       }
                    pv+=zz2;
                   }
              }
              else
              {
                 for(z=zz;z<zz+8;z++)
	             {
                      for(zz2=FONTY;zz2>0;zz2--)
                      {
                       n=tabla[z];
                       for (c=0;c<8;c++)
                          {
                           for(z2=FONTX;z2>0;z2--)
                            {
                             d=d1+x;
                             zz1=d;
                             pv=pvx+zz1;
                             if(pv<=pv1)
                                if(n&128) { *pv=INK;} else { *pv=PAPER;}
                             x++;
                            }
                           n=n<<1;
                          }
                       x+=Wancho-(FONTX<<3);
                      }
                     }
              }
         break;
         case 16:
          pvs1=(unsigned short int *)(pvx+tamaBuffer);
           if(FONTX==1 && FONTY==1)
              {
  	           d=d1+x;
                   zz1=d<<1;
                   pvs=(unsigned short int *) (pvx+zz1);
                   zz2=Wancho-8;
                   for(z=zz;z<zz+8;z++)
                   {
                    n=tabla[z];
                    for (c=0;c<8;c++)
                      {
                       if(pvs<=pvs1)
                       if(n&128) { *pvs=I2COLOR[INK];} else { *pvs=I2COLOR[PAPER];} 
                       pvs++;
                       n=n<<1;
                       }
                    pvs+=zz2;
                   }
              }
              else
              {
              for(z=zz;z<zz+8;z++)
	             {
                      for(zz2=FONTY;zz2>0;zz2--)
                      {
                       n=tabla[z];
                       for (c=0;c<8;c++)
                          {
                           for(z2=FONTX;z2>0;z2--)
                            {
                             d=d1+x;
                             zz1=d<<1;
                             pvs=(unsigned short int *)(pvx+zz1);
                             if(pvs<=pvs1)
                                if(n&128) { *pvs=I2COLOR[INK];} else { *pvs=I2COLOR[PAPER];}
                             x++;
                            }
                           n=n<<1;
                          }
                       x+=Wancho-(FONTX<<3);
                      }
                     }
              }
         break;
         
         default:
          pvi1=(unsigned  int *)(pvx+tamaBuffer);
           if(FONTX==1 && FONTY==1)
              {
  	           d=d1+x;
                   zz1=d<<2;
                   pvi=(unsigned  int *) (pvx+zz1);
                   zz2=Wancho-8;
                   for(z=zz;z<zz+8;z++)
                   {
                    n=tabla[z];
                    for (c=0;c<8;c++)
                      {
                       if(pvi<=pvi1)
                       if(n&128) { *pvi=I2COLOR[INK];} else { *pvi=I2COLOR[PAPER];} 
                       pvi++;
                       n=n<<1;
                       }
                    pvi+=zz2;
                   }
              }
              else
              {
              for(z=zz;z<zz+8;z++)
	             {
                      for(zz2=FONTY;zz2>0;zz2--)
                      {
                       n=tabla[z];
                       for (c=0;c<8;c++)
                          {
                           for(z2=FONTX;z2>0;z2--)
                            {
                             d=d1+x;
                             zz1=d<<2;
                             pvi=(unsigned  int *)(pvx+zz1);
                             if(pvi<=pvi1)
                                if(n&128) { *pvi=I2COLOR[INK];} else { *pvi=I2COLOR[PAPER];}
                             x++;
                            }
                           n=n<<1;
                          }
                       x+=Wancho-(FONTX<<3);
                      }
                     }
              }
         break;      
        }
          
    }
    else
    {
 	setcolor();
 	XDrawImageString (Midisplay,Miventana,Migc,x,y+FONTYY,(const char*) &ca,1); 
    }
}


/* ----- IMPRIME UNA CADENA ------- */
void printc(int x,int y,char *texto)
{
unsigned char z;
   setcolor();
   if(SETBUFFER==1)
      {	
	for(z=0;z<80 && texto[z]!=0;z++){ impri(x,y,texto[z]); x+=8*FONTX;}
      }
      else
      {
       XDrawImageString (Midisplay,Miventana,Migc,x,y+FONTYY,texto,strlen(texto));
      }
}
/* ---- IMPRIME NUMERO ----*/
void printn(int x,int y,long num)
{
int z;
 for(z=0;z<80;z++)VARI[z]=0;
 sprintf(VARI,"%d",num);
 printc(x,y,VARI);
}
 

/* ----- IMPRIME LINEA ------------ */
void line(int x,int y,int xx,int yy)
{
 unsigned short int z,c,a,vx,vy;

 if(SETBUFFER==1)
      {
                 if(x==xx)
	                {
                         if(y>yy){z=y;y=yy;yy=z;}
                         if(y<0) y=0;
                         if(yy>Walto)yy=Walto;
                         for(;y<=yy;y++)plot(x,y);
                         goto fin;
                        }

                 if(y==yy)
                    	{
                         if(x>xx){z=x;x=xx;xx=z;}
                         if(x<0)x=0;
                         if(xx>Wancho)xx=Wancho;
                         for(;x<=xx;x++)plot(x,y);
                         goto fin;
                        }
                        
                 if(x<xx)
                    if(y<yy)
                     goto normal;
                    else
                     goto nonormal;
                 if(x>xx)
                    if(y>yy)
                       {
                        z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto normal;
                       }
                       else
                       {
                        z=xx;xx=x;x=z;z=yy;yy=y;y=z; goto nonormal;
                       }
nonormal:
   		 vx=xx-x; vy=y-yy;a=0;
                 plot(xx,yy);
                 if(vx>vy)
                   {
                    c=vx;
                    while(c>0)
			{
			 c--;xx--;a+=vy;
			 if(a>=vx){a-=vx; yy++;}
			 plot(xx,yy);
			}
                   }
                     else
                   {
                    c=vy;
                    while(c>0)
			{
			 c--;yy++;a+=vx;
			 if(a>=vy){a-=vy;xx--;}
			 plot(xx,yy);
			}
                   }
                 goto fin;
normal:
   		 vx=xx-x;vy=yy-y;a=0;
                 plot(x,y);
                 if(vx>vy)
                 {
                  c=vx;
                  while(c>0)
			{
			 c--; x++; a=a+vy;
			 if(a>=vx){ a-=vx; y++; }
			 plot(x,y);
			}
                 }
		 else
                 {
                  c=vy;
                  while(c>0)
                     {
			 c--; y++; a=a+vx;
			 if(a>=vy){ a-=vy; x++; }
			 plot(x,y);
                     }
                 }
      }
      else
      {
       setcolor();
       XDrawLine (Midisplay,Miventana,Migc,x,y,xx,yy);
      }
fin:
;
}



/* ----- Imprime punto ------ */
void plot(int x,int y)
{
short int z1;
unsigned int z;
   if(x>Wancho || x<0 || y>Walto || y<0) goto fin;
   if(SETBUFFER==1)
      {
       switch(Midepth)
            {
             case 8:
                 pv=pvx;
                 z1=INK;
                 z=y*Wancho+x;
                 pv+=z;
                 *pv=z1;
             break;
             case 16:
                 pvs=(unsigned short int *) pvx;
                 z1=I2COLOR[INK];
                 z=y*Wancho+x;
                 pvs+=z;
                 *pvs=z1;
             break;
             default:
                 pvi=(unsigned  int *) pvx;
                 z=y*Wancho+x;
                 pvi+=z;
                 *pvi=I2COLOR[INK];
             break;
             
            }
      }
      else
      {
      	setcolor();
	XDrawPoint (Midisplay,Miventana,Migc,x,y);
      }
fin:
;
}


/* ----- BORRA PANTALLA ---- */
void clear(unsigned char c)
{
static unsigned char cc=100;
unsigned int z,z1,z2;
unsigned short sz1,sz2;

 if(SETBUFFER==1)
	{
         switch(Midepth)
         {
          case 8:
           pvs=(unsigned short *)pvx;
           sz2=c;
           sz1=sz2;
           sz1=sz1<<8;
           sz1=sz1 | sz2;
           for(z=0;z<tamaBuffer;z+=2){ *pvs=sz1; pvs++;}
          break;
          case 16:
             	 pvi=(unsigned  int *)pvx;
                 z2=I2COLOR[c];
                 z1=z2;		 
		 z1=z1 << 16;
		 z1=z1 | z2;
		 for(z=0;z<tamaBuffer;z+=4){ *pvi=z1; pvi++;}
          break;
          default:
             	 pvi=(unsigned  int *)pvx;
                 z2=I2COLOR[c];
                 z1=z2;		
                 for(z=0;z<tamaBuffer;z+=4){ *pvi=z1; pvi++;}
          break;
         }
	}
	else
	{
	  if(Midepth==8)
             if(cc!=c)XSetWindowBackground(Midisplay,Miventana,c);
            else
             if(cc!=c)XSetWindowBackground(Midisplay,Miventana,ICOLOR[c]);
          XClearWindow(Midisplay,Miventana);
	  cc=c;
	}
}

/* ----- LEE TECLA ----- */
void do_KeyPress (void)
{
   XKeyEvent *e = (XKeyEvent *) Mievent;
   KeySym ks;
   char str[256+1];
	XLookupString (e, str, 256, &ks, NULL);
     INKEY=str[0];
     INKEY2=e->keycode;
     NINKEY=0;
     NINKEY2=0; 
}
void do_KeyRelease (void)
{

   XKeyEvent *e = (XKeyEvent *) Mievent;
 KeySym ks;
 char str[256+1];
	XLookupString (e, str, 256, &ks, NULL);
    NINKEY=str[0];
    NINKEY2=e->keycode;
    INKEY=0;
    INKEY2=0; 
} 

int inkey(void)
{
char z;
    z=INKEY;
    INKEY=0;
 return(z);
}
int inkey2(void)
{
 int z;
    z=INKEY2;
    INKEY2=0;
 return(z);
}

/* ----- RUTINA DE LECTURA DE TECLA EN XWIN ------- */
int xinkey(void)
{
     XEvent event;
	XNextEvent (Midisplay, &event);
	Mievent=&event;
	switch (event.type)
         {
	  case KeyPress:
	    do_KeyPress ();
	    break;
	  case KeyRelease:
	    do_KeyRelease ();
	    break;
	  default:          
	    break;
	}
 return(inkey());
}

/* ------MOUSE ------ */
/*  3-(XMOUSE,YMOUSE) 4-KMOUSE */
void mouse(int x)
{
static int MX,MY,MK;
	if(x==3 || x==9)
	 {
	  	XMotionEvent *e = (XMotionEvent *) Mievent;
		XMOUSE = e->x;
		YMOUSE = e->y;
		CMOUSE=0;
	 }
	if(x==4)
	 {
		XButtonEvent *e = (XButtonEvent *) Mievent;
		KMOUSE = e->button;
		if(KMOUSE==1)KMOUSE=1;
		if(KMOUSE==3)KMOUSE=2;
		CMOUSE=0;
	 }
	if(x==5) {CMOUSE=0; KMOUSE=0;}
	if(MX!=XMOUSE || MY!=YMOUSE || MK!=KMOUSE) CMOUSE=1;
	MX=XMOUSE; MY=YMOUSE; MK=KMOUSE;
}

/* ---- CARGA FONTS -------*/


int loadfont(char *nombre)
{
 int x;
 if((pf=fopen(nombre,"rb"))==NULL)
	 {
	  printf("Cargando default font\n");
	  for(x=0;x<2040;x++)
		{
		  tabla[x]=dataFont[x];
		}
	  return(1);
	 }
	else
	 {
	  x=fread(VARI,1,1,pf);
	  if(VARI[0]=='S')
			{
			 x=fread(VARI+1,9,1,pf);
			 x=fread(tabla,2040,1,pf);
			}
		else
			{
			 tabla[0]=VARI[0];
			 x=fread(tabla+1,2040,1,pf);
			}
	  fclose(pf);
	 }
 return(0);
}


/*---- coloca paleta pal  ----*/
void paletapal()
{
   igetcolors();
}

/* --- Coloca los colores definidos en pal en la cadena ICOLOR --- */
void igetcolors(void)
{
short unsigned int rojo,verde,azul;
unsigned int x,zz,z2;
long int z3;
 for(x=0;x<256;x++)
	{
	 zz=x*3;
         Micolor.flags = DoRed | DoGreen | DoBlue;
	 Micolor.red=pal[zz]<<10;
	 Micolor.green=pal[zz+1]<<10;
	 Micolor.blue=pal[zz+2]<<10;
	 XAllocColor(Midisplay,Mimapa,&Micolor);
	 ICOLOR[x]=Micolor.pixel;
/*         printf("color%d-%x ",x,ICOLOR[x]);   */
         switch(Midepth)
            {
             case 8:
                 I2COLOR[x]=ICOLOR[x];
                break;
             case 16:
                 z3=ICOLOR[x];
                 azul=z3&0xffff; z3=z3>>16;
                 verde=z3&0xffff; z3=z3>>16;
                 rojo=z3&0xffff; 
                 azul>>11;
                 verde>>10;
                 rojo>>11;
                 z2=rojo; z2=z2<<6;
                 z2=z2 | verde; z2=z2<<5;
                 z2=z2 | azul;
                 I2COLOR[x]=z2&0xffff;
             break;
             default:
                 I2COLOR[x]=ICOLOR[x];
             break;
            }
	}
}

/* ------ Coloca caracter ----------- */
void setfont(char *nombre)
{
	if(0==strcmp(nombre,"8x16"))
		{
   		 Mifont=XLoadFont(Midisplay,"8x16");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=8;FONTYY=16;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
	if(0==strcmp(nombre,"9x15"))
		{
   		 Mifont=XLoadFont(Midisplay,"9x15");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=9;FONTYY=15;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
	if(0==strcmp(nombre,"6x10"))
		{
   		 Mifont=XLoadFont(Midisplay,"6x10");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=6;FONTYY=10;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
	if(0==strcmp(nombre,"7x14"))
		{
   		 Mifont=XLoadFont(Midisplay,"7x14");
		 if(Mifont==0) goto salto;
		 XSetFont(Midisplay,Migc,Mifont);
   		 FONTXX=7;FONTYY=14;
   		 FONTX=1;FONTY=2;
   		 goto fin;
   		}
salto:
   	 Mifont=XLoadFont(Midisplay,"6x*");
	 XSetFont(Midisplay,Migc,Mifont);
  	 FONTXX=6;FONTYY=8;
   	 FONTX=1;FONTY=1;
fin:
;
}

void mode(int mode_code)
{
 XSizeHints *sizehints;
    if(mode_code==2 || mode_code==3)
	{
         XCloseDisplay(Midisplay);
         free(pixmapBuffer);
         goto fin;
        }
    Midisplay = XOpenDisplay (NULL);
    if (!Midisplay)
     {	fprintf (stderr, "Imposible abrir display \n"); exit (1); }
    Mipantalla = DefaultScreen (Midisplay);
    Miattr.event_mask = KeyPressMask | KeyReleaseMask | ButtonPressMask |
			   ButtonReleaseMask | EnterWindowMask |
			   LeaveWindowMask | PointerMotionMask | 
			   Button1MotionMask |
			   Button2MotionMask | Button3MotionMask |
			   Button4MotionMask | Button5MotionMask |
			   ButtonMotionMask | KeymapStateMask |
			   ExposureMask | VisibilityChangeMask | 
			   StructureNotifyMask |
			   SubstructureNotifyMask | SubstructureRedirectMask |
			   FocusChangeMask | PropertyChangeMask |
			   ColormapChangeMask | OwnerGrabButtonMask;

    Miattr.background_pixel = WhitePixel(Midisplay,Mipantalla);
    Miattr.border_pixel = BlackPixel(Midisplay,Mipantalla);
    Mimask |= (CWBackPixel | CWBorderPixel | CWEventMask);

    switch(mode_code)
	{
	 case -1:
		Wancho= wXWIN; Walto= hXWIN;
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            Wancho,  Walto,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
		
		break;
	 case 10:
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            640, 480,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
		Wancho=640; Walto=480;
		break;
	 case 13:
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            320, 200,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
		Wancho=320; Walto=200;
	  break;
	 default:
	    Miventana = XCreateWindow (Midisplay, RootWindow (Midisplay, Mipantalla), 100, 100,
            320, 200,10, 0,InputOutput, (Visual *)CopyFromParent,Mimask,&Miattr);
		Wancho=320; Walto=200;
	}
    
    	sizehints = XAllocSizeHints();
	if(sizehints) {
		sizehints->min_width = Wancho;
		sizehints->min_height =  Walto;
		sizehints->max_width =  Wancho;
		sizehints->max_height =  Walto;
		sizehints->base_width =  Wancho;
		sizehints->base_height =  Walto;
		sizehints->flags = PMinSize | PMaxSize | PBaseSize;
		XSetWMNormalHints(Midisplay, Miventana, sizehints);
		XFree(sizehints);
	}
           
    XSetStandardProperties(Midisplay,Miventana,VARI,VARI,None,NULL,0,NULL);
    XMapWindow (Midisplay, Miventana);
    waitx(10);
	XFlush(Midisplay);
	Migc=DefaultGC(Midisplay,Mipantalla);
	Mivisual = DefaultVisual(Midisplay,Mipantalla);
	Midepth  = DefaultDepth(Midisplay,Mipantalla);
/*
        if(Midepth==8)
            Mimapa = XCreateColormap(Midisplay,XDefaultRootWindow(Midisplay),Mivisual,AllocAll);
         else
*/
            Mimapa=DefaultColormap(Midisplay,Mipantalla); 
    printf("Libreria SETA \ndepth=%d %dx%d\n",Midepth,Wancho,Walto);
  	XMoveWindow(Midisplay,Miventana,16,16);
  	switch(Midepth)
		{
		 case 8:
		  nbscreen=1;     break;
		 case 15:
		  nbscreen=2;	  break;
		 case 16:
		  nbscreen=2;	  break;
		 default:
		  nbscreen=4;
		}
	tamaBuffer=nbscreen*Wancho*Walto;
	pixmapBuffer =(char *) malloc( tamaBuffer );
        
	offscreenBuffer = XCreateImage( Midisplay, Mivisual, Midepth, ZPixmap, 0,
                (char *) pixmapBuffer, Wancho, Walto, (Midepth==8)?8:32, 0);
	pvx=pixmapBuffer;;
	setfont((char *)"-");

fin:
;
}
/* ----- Imprime cuadrado ----- */
void box(int x,int y,int xx,int yy)
{
	setcolor();
	line(x,y,xx,y);
	line(xx,y,xx,yy);
	line(xx,yy,x,yy);
	line(x,yy,x,y);
}


/* ----- Imprime cuadrado relleno----- */
void bar(int x,int y,int xx,int yy)
{
int  d;
int c,cc,z1;

	if(x>xx){d=x; x=xx; xx=d;}
  	if(y>yy){d=y; y=yy; yy=d;}
	setcolor();
 if(SETBUFFER==1)
      {
       if(x<0)x=0;
       if(xx<0)xx=0;
       if(y<0)y=0;
       if(yy<0)yy=0;
       if(x>=Wancho)x=Wancho-1;
       if(xx>=Wancho)xx=Wancho-1;
       if(y>=Walto)y=Walto-1;
       if(yy>=Walto)yy=Walto-1;
        switch(Midepth)
         {
         case 8:
	         for(cc=y;cc<=yy;cc++)
                    {
                     d=cc*Wancho+x;
                     z1=d;
                     pv=pvx+z1;
                     for(c=x;c<=xx;c++)
			{
			 *pv=INK;
			 pv++;
			}
                     }
          break;
          case 16:
	         for(cc=y;cc<=yy;cc++)
                    {
                     d=cc*Wancho+x;
                     z1=d<<1;
                     pvs=(unsigned short int *) (pvx+z1);
            for(c=x;c<=xx;c++)
			{
			 *pvs=I2COLOR[INK];
			 pvs++;
			}
                     }
          break;
          default:
	         for(cc=y;cc<=yy;cc++)
                    {
                     d=cc*Wancho+x;
                     z1=d<<2;
                     pvi=(unsigned  int *) (pvx+z1);
                     for(c=x;c<=xx;c++)
			{
			 *pvi=I2COLOR[INK];
			 pvi++;
			}
                     }
          break;
         }
      }
      else
      {
	XFillRectangle(Midisplay,Miventana,Migc,x,y,xx-x,yy-y);
      }
}


/* -----Cambia la tinta y el papel en curso ---- */
void setcolor(void)
{
static unsigned char i,p;

	if(PAPER!=p || INK!=i)
		{
                 if(Midepth==8)
                    {
                     Migcv.foreground=INK;
                     Migcv.background=PAPER;
                    }
                  else
                    { 
                     Migcv.foreground=ICOLOR[INK];
                     Migcv.background=ICOLOR[PAPER];
                     
                    }
                 XChangeGC(Midisplay,Migc,GCForeground|GCBackground,&Migcv);
		 p=PAPER; i=INK;
		}
}

/*---- coloca paleta por defecto ----*/
void paleta()
{
 int z;

 	for(z=0;z<48;z++) pal[z]=tleta[z];
	igetcolors();

}


/* ------ Tratamiento de errores ----- */
void error(int z)
{
	switch(z)
		{
		 case 2:
			printc(0,0,(char *)"Fichero no encontrado");
			break;
		 case 8:
			printc(0,0,(char *)"Memoria insuficiente");
			break;
		 case 13:
			printc(0,0,(char *)"Dato invalido");
			break;
		 default:
			printc(0,0,(char *)"Error desconocido");
			break;
		}
}


//Rutinas de tiempo________________________

/* ---- devuelve tiempo del sistema ---- */
unsigned int Ctime(void)
{

struct timeval tv;
unsigned int z,zz;
	gettimeofday(&tv,NULL);
	z=tv.tv_usec/10000;
	zz=(tv.tv_sec & 0x00fff)*100;
	return(zz+z);
}

/* --------- Sleep for n microseconds --------*/
void waitm(int n)
{
  struct timeval value;
  
  if (n <= 0)
    return;
  
  value.tv_usec = n % 1000000;
  value.tv_sec = n / 1000000;
  
  (void) select(1, 0, 0, 0, &value);
}

void waitx(int s)
{
unsigned int z;
	z=s*4;
	z+=(Ctime());
	if(z-Ctime()>500) goto fin;
 	while(Ctime()<z);
fin:
;
}
/* espera s segundos */
void waits(int s)
{
   waitx(s*25);
}

//________________________________________
